<?php
class tx_odsosm_leaflet extends tx_odsosm_common {
	public function getMapCore($backpath=''){
		$path=$backpath.t3lib_extMgm::siteRelPath('ods_osm').'res/';
		$GLOBALS['TSFE']->getPageRenderer()->addCssFile($path.'leaflet/leaflet.css');
		$scripts=array($path.'leaflet/leaflet.js');
		tx_odsosm_div::addJsFiles($scripts);
	}

	public function getMapMain(){
		return "var ".$this->config['id']."=new L.Map('".$this->config['id']."');";
	}

	public function getLayer($layer,$i,$backpath=''){
		$name=preg_replace('/[^a-z]/','',strtolower($layer['title']));
		return '
			var '.$name.' = new L.TileLayer(\''.$layer['tile_url'].'\', {
				attribution: \'Map data &copy; <a href="http://openstreetmap.org">OpenStreetMap</a> contributors\',
				maxZoom: '.$layer['max_zoom'].'
			});
			'.$this->config['id'].'.addLayer('.$name.');
		';
	}

	public function getMapCenter($lat,$lon,$zoom){
		return '
			var center = new L.LatLng('.floatval($lat).','.floatval($lon).');
			'.$this->config['id'].'.setView(center,'.intval($zoom).');
		';
	}

	public function getMarker($item,$table,$text){
		$jsMarker='';
		switch($table){
			case 'fe_users':
			case 'tt_address':
				$jsMarker='var markerLocation = new L.LatLng('.$item['tx_odsosm_lat'].', '.$item['tx_odsosm_lon'].');
				var marker = new L.Marker(markerLocation);
				'.$this->config['id'].'.addLayer(marker);';
				break;
		}
		return $jsMarker;
	}

	public function getMarkerLayer(){
	}
}
?>