<?php
class tx_odsosm_static extends tx_odsosm_common {
	protected $uploadPath = 'uploads/tx_odsosm/';

	public function getMap(){
		foreach($this->config['marker'] as $table=>$items){
			foreach($items as $item){
				switch($table){
					case 'fe_users':
					case 'tt_address':
						if($item['tx_odsosm_marker'] && is_array($this->markers[$item['tx_odsosm_marker']])){
							$marker=$this->markers[$item['tx_odsosm_marker']];
							$icon='uploads/tx_odsosm/'.$marker['icon'];
						}else{
							$marker=array('size_x'=>21,'size_y'=>25,'offset_x'=>-11,'offset_y'=>-25);
							$icon='EXT:ods_osm/res/marker.png';
						}
					break 3;
				}
			}
		}

		$markerUrl=array(
			'###lat###'=>floatval($item['tx_odsosm_lat']),
			'###lon###'=>floatval($item['tx_odsosm_lon']),
			'###zoom###'=>intval($this->config['zoom']),
			'###width###'=>intval($this->config['width']),
			'###height###'=>intval($this->config['height']),
		);

		$res=$GLOBALS['TYPO3_DB']->exec_SELECTquery('static_url','tx_odsosm_layer','uid='.$this->config['layer'][0].$this->cObj->enableFields('tx_odsosm_layer'));
		$layer=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
		$url=strtr($layer['static_url'],$markerUrl);
		$filename=$this->uploadPath.'map/'.md5($url).'.png';

		// Cache image
		$cache=false;
		if(file_exists($filename)) $cache=filectime($filename)>time()-7*24*60*60;
		if(!$cache){
			$image=file_get_contents($url);
			if($image) file_put_contents($filename,$image);
		}

		// Generate image tag
//		$config['file'] = $filename;
		$config=array(
			'file'=>'GIFBUILDER',
			'file.'=>array(
				'format'=>'png',
				'XY'=>'[10.w],[10.h]',
				'10'=>'IMAGE',
				'10.'=>array(
					'file'=>$filename,
				),
				'20'=>'IMAGE',
				'20.'=>array(
					'offset'=>($this->config['width']/2+$marker['offset_x']).','.($this->config['height']/2+$marker['offset_y']),
					'file'=>$icon,
				),
			),
		);

		$content=$this->cObj->IMAGE($config);
		return($content);
	}
}
?>
